"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _point = _interopRequireDefault(require("../geo/point"));

function _createForOfIteratorHelper(o, allowArrayLike) { var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"]; if (!it) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = it.call(o); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it.return != null) it.return(); } finally { if (didErr) throw err; } } }; }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

var DOM = {};
var _default = DOM;
exports.default = _default;

DOM.create = function (tagName, className, container) {
  return null;
};

DOM.createNS = function (namespaceURI, tagName) {
  return null;
};

function testProp(props) {
  return props[0];
}

var selectProp = testProp(['userSelect', 'MozUserSelect', 'WebkitUserSelect', 'msUserSelect']);

DOM.disableDrag = function () {};

DOM.enableDrag = function () {};

var transformProp = testProp(['transform', 'WebkitTransform']);

DOM.setTransform = function (el, value) {
  el.style[transformProp] = value;
};

var passiveSupported = false;

try {
  var options = Object.defineProperty({}, 'passive', {
    get: function get() {
      passiveSupported = true;
    }
  });
} catch (err) {
  passiveSupported = false;
}

DOM.addEventListener = function (target, type, callback) {
  var options = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : {};

  if ('passive' in options && passiveSupported) {
    target.addEventListener(type, callback, options);
  } else {
    target.addEventListener(type, callback, options.capture);
  }
};

DOM.removeEventListener = function (target, type, callback) {
  var options = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : {};

  if ('passive' in options && passiveSupported) {
    target.removeEventListener(type, callback, options);
  } else {
    target.removeEventListener(type, callback, options.capture);
  }
};

var suppressClick = function suppressClick(e) {
  e.preventDefault();
  e.stopPropagation();
};

DOM.suppressClick = function () {};

DOM.mousePos = function (el, e) {
  var rect = el.getBoundingClientRect();
  return new _point.default(e.clientX - rect.left - el.clientLeft, e.clientY - rect.top - el.clientTop);
};

DOM.touchPos = function (el, touches) {
  var rect = el.getBoundingClientRect();
  var points = [];

  var _iterator = _createForOfIteratorHelper(touches),
      _step;

  try {
    for (_iterator.s(); !(_step = _iterator.n()).done;) {
      var touche = _step.value;
      points.push(new _point.default(touche.clientX - rect.left - el.clientLeft, touche.clientY - rect.top - el.clientTop));
    }
  } catch (err) {
    _iterator.e(err);
  } finally {
    _iterator.f();
  }

  return points;
};

DOM.mouseButton = function (e) {};

DOM.remove = function (node) {
  if (node.parentNode) {
    node.parentNode.removeChild(node);
  }
};
//# sourceMappingURL=dom.js.map